//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop
#include <stdio.h>
#include <stdlib.h>
#include <io.h>

#include "CdVehicle.cpp"
#include "Main.h"
#include "ZadajCd.cpp"
#include "About.cpp"
#include "VypisCd.cpp"
#include "Triedenie.cpp"
#include "Vyhladaj.cpp"


//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TMainForm *MainForm;
CdVehicle *PrveCd;
CdVehicle *AktualneCd;
CdVehicle *AktualneCd2;
CdVehicle *CdDatabaza;
CDVehicle *PrveHladane;
AnsiString NahrajData(FILE *DataFile);
AnsiString Najdi(int Polozka,int k);
int PolozkaVyhladaj = 0;
int PolozkaTriedenie = 0;
int PocetCd;
int PocetHladane = 0;
int PocetPozicane;
AnsiString MenoSuboru;
AnsiString Prvok1;
AnsiString Prvok2;


AnsiString NahrajData(FILE *DataFile)
{
  char ch;
  AnsiString Retazec="";
  while(1) {
    ch=fgetc(DataFile);
    if(ch=='\0') return NULL;
    if(ch=='|') return Retazec;
    Retazec=Retazec+ch;
    }
  return Retazec;
}

void Chyba(int Kolko);
void Umiestni(int j,AnsiString Prvok2);

//---------------------------------------------------------------------------
__fastcall TMainForm::TMainForm(TComponent* Owner)
  : TForm(Owner)
{
SaveDialog->Filter="Cd Databaza (*.cdb)|*.cdb";
SaveDialog->DefaultExt="cdb";
OpenDialog->Filter="Cd Databaza (*.cdb)|*.cdb";
OpenDialog->DefaultExt="cdb";

}
//---------------------------------------------------------------------------
void __fastcall TMainForm::End1Click(TObject *Sender)
{
if(Save->Enabled==true) {
    if(Application->MessageBox("Nemas Ulozene data! \nChces naozaj skoncit?",
      "Pozor!",MB_OKCANCEL+MB_ICONWARNING)==IDCANCEL) return;
  }
  Application->Terminate();
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::PridajZaznamCD1Click(TObject *Sender)
{
  FormZadajCd->ShowModal();
  LabelPocetCd->Caption = PocetCd;
  Save->Enabled = true;
  }
//---------------------------------------------------------------------------
void __fastcall TMainForm::Oprograme1Click(TObject *Sender)
{
    AboutForm->ShowModal();
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::OpenClick(TObject *Sender)
{
  FILE *DataFile;
  AnsiString Pomocny;
  if(Save->Enabled==true)
    if(Application->MessageBox("Nemas ulozene vytvorene polozky!\nPokracovat?",
            "Pozor!",MB_OKCANCEL+MB_ICONWARNING) ==IDCANCEL)
        return;
//Zmaze uz existujuce data - uvolnenie pamete

  while(PocetCd) {
    AktualneCd=PrveCd;
    for(int i=1;i<PocetCd;i++)
      AktualneCd=AktualneCd->getDalsi();
    delete AktualneCd;
    PocetCd--;
  }
  if(OpenDialog->Execute()) {
    DataFile=fopen(OpenDialog->FileName.c_str(),"rt");
    fscanf(DataFile,"%d",&PocetCd);
    for(int i=0;i<PocetCd;i++) {
      CdVehicle *CdDatabaza = new CdVehicle();
      if(i>0) AktualneCd->setDalsi(CdDatabaza);
      if(i==1) PrveCd->setDalsi(CdDatabaza);
      Pomocny="";
      for(int j=0;j<10;j++) {
        AnsiString Este;
        if((Este=NahrajData(DataFile))==NULL) {Chyba(i);Save->Enabled=false; return;};
        Pomocny=Pomocny+Este;
        }
      Pomocny=Pomocny+'|';
      CdDatabaza->setSong(Pomocny);
      if((Pomocny=NahrajData(DataFile))==NULL) {Chyba(i);Save->Enabled=false;return;};
      CdDatabaza->setNameCd(Pomocny);
      if((Pomocny=NahrajData(DataFile))==NULL) {Chyba(i);Save->Enabled=false;return;};
      CdDatabaza->setAutor(Pomocny);
      if((Pomocny=NahrajData(DataFile))==NULL) {Chyba(i);Save->Enabled=false;return;};
      CdDatabaza->setTyp(Pomocny);
      if((Pomocny=NahrajData(DataFile))==NULL) {Chyba(i);Save->Enabled=false;return;};
      CdDatabaza->setPozicane(Pomocny);
      if((Pomocny=NahrajData(DataFile))==NULL) {Chyba(i);Save->Enabled=false;return;};
      CdDatabaza->setMeno(Pomocny);
      if((Pomocny=NahrajData(DataFile))==NULL) {Chyba(i);Save->Enabled=false;return;};
      CdDatabaza->setPriezvisko(Pomocny);
      if((Pomocny=NahrajData(DataFile))==NULL) {Chyba(i);Save->Enabled=false;return;};
      CdDatabaza->setPozicaneDo(Pomocny);
      AktualneCd = CdDatabaza;
      if(i==0) PrveCd=CdDatabaza;
    }
    fclose(DataFile);
    LabelPocetCd->Caption = PocetCd;
    Save->Enabled=false;
  }
}

//---------------------------------------------------------------------------
void __fastcall TMainForm::SaveClick(TObject *Sender)
{
CdVehicle *Jedna = PrveCd;
FILE *DataFile;
if(SaveDialog->Execute()) {
  DataFile=fopen(SaveDialog->FileName.c_str(),"wt");
  fprintf(DataFile,"%d",PocetCd);
  for(int i=1;i<=PocetCd;i++) {
    fprintf(DataFile,"%s",Jedna->getSong());
    fprintf(DataFile,"%s|",Jedna->getNameCd());
    fprintf(DataFile,"%s|",Jedna->getAutor());
    fprintf(DataFile,"%s|",Jedna->getTyp());
    fprintf(DataFile,"%s|",Jedna->getPozicane());
    fprintf(DataFile,"%s|",Jedna->getMeno());
    fprintf(DataFile,"%s|",Jedna->getPriezvisko());
    fprintf(DataFile,"%s|",Jedna->getPozicaneDo());
    if(i!=PocetCd) Jedna = Jedna->getDalsi();
    }
  }
fclose(DataFile);
Save->Enabled = false;
}
//--------------------------------------------------------------------------
void __fastcall TMainForm::SaveDialogCanClose(TObject *Sender,
      bool &CanClose)
{
 MenoSuboru = SaveDialog->FileName;
 CanClose = true;
}
//---------------------------------------------------------------------------


void __fastcall TMainForm::Vypispoziciek1Click(TObject *Sender)
{
Application->CreateForm(__classid(TVypisForm), &VypisForm);
VypisForm->ShowModal();
delete VypisForm;
}
//---------------------------------------------------------------------------
void Chyba(int Kolko)
{
  Kolko--;
  while(Kolko) {
    AktualneCd=PrveCd;
    for(int i=1;i<Kolko;i++)
      AktualneCd=AktualneCd->getDalsi();
    delete AktualneCd;
    Kolko--;
  }
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::Vybertriedenia1Click(TObject *Sender)
{
FormTried->ShowModal();

}
//---------------------------------------------------------------------------
void __fastcall TMainForm::NastavenieVyhladavania1Click(TObject *Sender)
{
  FormVyhladaj->ShowModal();
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::Triedenie1Click(TObject *Sender)
{
  Save->Enabled = true;
  AktualneCd = PrveCd;
  for(int i=1;i<PocetCd;i++) {
    ProgressBar->Position = i+1;
    ProgressBar->Max = PocetCd;
    AktualneCd2 = AktualneCd->getDalsi();
    Prvok1 = Najdi(PolozkaTriedenie,i);
    Prvok2 = Najdi(PolozkaTriedenie,i+1);
    if(Prvok1>Prvok2) Umiestni(i+1,Prvok2);
    AktualneCd=PrveCd;
    for(int p=1;p<=i;p++)
      AktualneCd=AktualneCd->getDalsi();
  };
  ProgressBar->Position = 0;

}
//---------------------------------------------------------------------------

void Umiestni(int j,AnsiString Prvok2)
{
  CdVehicle *Buff = PrveCd;
  CdVehicle *Buff2 = AktualneCd2;
  AktualneCd->setDalsi(AktualneCd2->getDalsi());
  for(int k=1;k<=j;k++) {
    Prvok1=Najdi(PolozkaTriedenie,k);
    if(Prvok1>Prvok2)
      {
      if(k==1) {
        AktualneCd2->setDalsi(PrveCd);
        PrveCd=AktualneCd2;
        return;
      }
      Buff2=Buff->getDalsi();
      Buff->setDalsi(AktualneCd2);
      AktualneCd2->setDalsi(Buff2);
      return;
    }
    if(k>1)Buff=Buff->getDalsi();
  }
}

AnsiString Najdi(int Polozka,int f)
{
  CdVehicle *Dalsi=PrveCd;
  for(int p=1;p<f;p++)
    Dalsi = Dalsi->getDalsi();
  switch(Polozka) {
    case 0:return Dalsi->getPozicane();
    case 1:return Dalsi->getPozicaneDo();
    case 2:return Dalsi->getNameCd();
    case 3:return Dalsi->getAutor();
    case 4:return Dalsi->getPriezvisko();
  };
return NULL;
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::FormClose(TObject *Sender, TCloseAction &Action)
{
  if(Save->Enabled==true) {
    if(Application->MessageBox("Nemas Ulozene data! \nChces naozaj skoncit?",
      "Pozor!",MB_OKCANCEL+MB_ICONWARNING)==IDCANCEL) return;
  }
  Application->Terminate();
}
//---------------------------------------------------------------------------

